import { ElementRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { Annotation } from '../../models/annotation.model';
import { ISelection } from '../../models/selection.model';
import { TokenizerService } from '../../services/tokenizer.service';
export declare class NgxAnnotateTextComponent implements OnInit, OnChanges {
    private elementRef;
    private tokenService;
    /** Represents the parts of the given text which shall be annotated. */
    annotations: Annotation[];
    /** An optional CSS class applied to all elements which wrap the annotated parts of the given text. */
    annotationClass: string;
    /**
     * Determines whether annotations shall have a small button in the top right corner so that the user can
     * remove an annotation.
     */
    removable: boolean;
    /** The text which shall be displayed and annotated. */
    text: string;
    /** Emits the list of existing annotations after an element has been removed. */
    annotationsChange: EventEmitter<Annotation[]>;
    private selectionStart;
    private selectionEnd;
    constructor(elementRef: ElementRef, tokenService: TokenizerService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Returns the start index and end index of the currently selected text range. Returns `undefined`
     * if no text is currently selected.
     */
    getCurrentTextSelection(): ISelection;
    private updateTextSelection;
}
